<script lang="ts">
  import { rankTitle } from "./card/cardUtils";

  enum Reference {
    Card = "card",
    Scoring = "scoring",
  }

  let reference: Reference = Reference.Card;
  export let settings: GameSettings;
</script>

<section class="panel shadow border">
  <header>
    <label>
      <input type="radio" bind:group={reference} value={Reference.Card} />
      <span>Card Reference</span>
    </label>
    <label>
      <input type="radio" bind:group={reference} value={Reference.Scoring} />
      <span>Scoring Reference</span>
    </label>
  </header>
  <article class="content">
    {#if reference === Reference.Card}
      <dl>
        <dt>11</dt>
        <dd>
          <strong>{rankTitle("11")}:</strong>
          <span>
            When you lead this, if your opponent has a card of this suit, they
            must play either the 1 of this suit or their highest ranked card of
            this suit.
          </span>
        </dd>

        <dt>9</dt>
        <dd>
          <strong>{rankTitle("9")}:</strong>
          <span>
            When determining the winner of a trick with only one 9, treat the 9
            as if it were in the trump suit.
          </span>
        </dd>

        <dt>7</dt>
        <dd>
          <strong>{rankTitle("7")}:</strong>
          <span>
            The winner of the trick receives 1 point for each 7 in the trick.
          </span>
        </dd>

        <dt>5</dt>
        <dd>
          <strong>{rankTitle("5")}:</strong>
          <span>
            When you play this, draw 1 card. Then discard any 1 card to the
            bottom of the deck (face down).
          </span>
        </dd>

        <dt>3</dt>
        <dd>
          <strong>{rankTitle("3")}:</strong>
          <span>
            When you play this, you may exchange the trump card with a card from
            your hand.
          </span>
        </dd>

        <dt>1</dt>
        <dd>
          <strong>{rankTitle("1")}:</strong>
          <span>
            If you play this and lose the trick, you lead the next trick.
          </span>
        </dd>
      </dl>
    {:else if reference === Reference.Scoring}
      <div class="scoring-descriptions">
        <h3>Goal</h3>
        <p>
          The game ends at the end of a round when any player has reached
          <strong>{settings.goal}</strong> points. Whoever has the most points is
          the winner.
        </p>
        <h3>After each trick</h3>
        <p>
          The winner receives 1 point for each 7 ({rankTitle("7")}) in the
          trick.
        </p>

        <h3>After each round</h3>
        <p>
          The players each earn points based on how many tricks they won in the
          round.
        </p>
      </div>

      <table>
        <thead>
          <tr>
            <th>Tricks</th>
            <th>Points</th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>0-3</td>
            <td>6</td>
          </tr>
          <tr>
            <td>4</td>
            <td>1</td>
          </tr>
          <tr>
            <td>5</td>
            <td>2</td>
          </tr>
          <tr>
            <td>6</td>
            <td>3</td>
          </tr>
          <tr>
            <td>7-9</td>
            <td>6</td>
          </tr>
          <tr>
            <td>10-13</td>
            <td>0</td>
          </tr>
        </tbody>
      </table>
    {/if}
  </article>
</section>

<style>
  section {
    padding: 0;
    height: 100%;
    /* position: relative; */
    overflow-y: auto;
    background-color: linen;
  }

  header {
    padding: 1em;
    position: sticky;
    top: 0;
    background-color: linen;
    z-index: 10;

    font-family: Domine, serif;
    display: flex;
    justify-content: space-between;
  }
  .content {
    font-family: "PT Sans Narrow", sans-serif;
    margin-left: 1rem;
    margin-right: 1rem;
    margin-bottom: 1rem;
  }
  label {
    position: relative;
  }
  input[type="radio"] {
    opacity: 0;
    position: absolute;
  }
  input:checked + span {
    text-decoration: underline;
  }

  dl {
    margin-top: 0;
    display: grid;
    grid-template-columns: 2em 1fr;
    grid-row-gap: 1em;
  }
  dt {
    display: inline-block;
    font-family: Domine, serif;
    font-size: 2em;
    justify-self: center;
    transform: translateY(-0.15em);
  }
  dd {
    margin-left: 0;
  }

  .scoring-descriptions > h3 {
    font-weight: 600;
    font-size: 1.1rem;
    margin-bottom: 0.25rem;
  }
  .scoring-descriptions > p {
    margin-top: 0.25rem;
  }
  table {
    width: 100%;
    text-align: center;
    border-collapse: collapse;
    border-style: hidden;
  }
  table td,
  table th {
    border: 0.1em solid rgb(206, 206, 206);
  }
</style>
